(*
 * Hoare Logic,
 * Annotated version --> Definition
 * 
 * CVS : $Id: tlhlAnnotDef.v,v 1.4 2005/03/29 14:02:41 mpapakyr Exp $
*)

Require Export tlhlDefinitions.

Inductive AExpr : Type :=
    aeint   : Int  -> AExpr
  | aebool  : Bool -> AExpr
  | aevar   : Var  -> AExpr
  | aeunop  : UnOp -> AExpr -> AExpr
  | aebinop : BinOp -> AExpr -> AExpr -> AExpr
  | aeweak  : forall g : Env,
              forall P : Pred g,
              forall Q : Pred g,
                 pred_implies g P Q -> AExpr -> AExpr
.

Inductive AComm : Type :=
    acskip   : AComm
  | acassign : Var -> AExpr -> AComm
  | acseq    : AComm -> AComm -> AComm
  | acif     : AExpr -> AComm -> AComm -> AComm
  | acwhile  : forall g : Env,
                 Pred g -> AExpr -> AComm -> AComm
  | acassert : forall g : Env,
               forall P : Pred g,
               forall Q : Pred g,
                  pred_implies g P Q -> AComm
.
