(*
 * Hoare Logic,
 * Plain version --> Definitions
 * 
 * CVS : $Id: tlhlPlainDef.v,v 1.3 2005/03/21 14:45:11 mpapakyr Exp $ 
*)

Require Export tlhlDefinitions.

Inductive Expr : Type :=
    eint   : Int  -> Expr
  | ebool  : Bool -> Expr
  | evar   : Var  -> Expr
  | eunop  : UnOp -> Expr -> Expr
  | ebinop : BinOp -> Expr -> Expr -> Expr
.

Inductive Comm : Type :=
    cskip   : Comm
  | cassign : Var -> Expr -> Comm
  | cseq    : Comm -> Comm -> Comm
  | cif     : Expr -> Comm -> Comm -> Comm
  | cwhile  : Expr -> Comm -> Comm
.

