(*
 * Hoare Logic,
 * Plain version --> Soundness
 * 
 * CVS : $Id: tlhlPlainSound.v,v 1.5 2005/04/12 01:29:57 nickie Exp $ 
*)

Require Export tlhlPlainSem.
Require Export tlhlPlainLogic.
 
Theorem LogicIsSoundE:
   forall g : Env,
   forall e : Expr,
   forall t : Omega,
   forall P : Pred g,
   forall F : semT t -> Pred g,
   SpecE g e t P F ->
   forall s : Store g,
   forall v : semT t,
   semE g e t s v ->
      P s -> F v s
.
Proof.
intros g e t P F Hspec.
induction Hspec.
 intros s v Hsem.
   inversion Hsem.
   assert (n = v).
  apply inj_pair2 with (P := semT) (p := uint).
    assumption.
  rewrite H.
    trivial.
 intros s v Hsem.
   inversion Hsem.
   assert (b = v).
  apply inj_pair2 with (P := semT) (p := ubool).
    assumption.
  rewrite H.
    trivial.
 intros s v Hsem.
   inversion Hsem.
   assert (s x = v).
  apply inj_pair2 with (P := semT) (p := g x).
    assumption.
  rewrite H2.
    trivial.
 intros s v Hsem.
   inversion Hsem.
   assert (unopFun op v0 = v).
  apply inj_pair2 with (P := semT) (p := unopTR op).
    assumption.
  rewrite <- H4.
    apply IHHspec.
    assumption.
 intros s v Hsem.
   inversion Hsem.
   assert (binopFun op v1 v2 = v).
  apply inj_pair2 with (P := semT) (p := binopTR op).
    assumption.
  rewrite <- H8.
    intro Hpre.
    apply H0.
   assumption.
   apply IHHspec.
    assumption.
    assumption.
 intros s v Hsem.
   intro Hpre.
   apply IHHspec.
  assumption.
  apply p.
    assumption.
Qed.

Lemma while_ind :
   forall g : Env,
   forall e : Expr,
   forall c : Comm,
   forall P : Store g -> Store g -> Prop,
      (forall s : Store g,
         semE g e ubool s false -> P s s) ->
      (forall s  : Store g,
       forall s' : Store g,
       forall s'' : Store g,
         semE g e ubool s true ->
         semC g c s s' ->
         semC g (cwhile e c) s' s'' ->
            P s' s'' -> P s s'') ->
      forall s  : Store g,
      forall s' : Store g,
         semC g (cwhile e c) s s' -> P s s'
.
(* In previous CVS versions there is a fixpoint version of this lemma *)
Proof.
intros g e c P Hf Ht s s'.
set (cw := cwhile e c) in |- *.
assert (cw = cwhile e c).
 unfold cw in |- *.
   reflexivity.
 intro Hsem.
   induction Hsem.
  discriminate H.
  discriminate H.
  discriminate H.
  discriminate H.
  discriminate H.
  injection H.
    intros H1 H2.
    apply Ht with (s' := s1).
   rewrite <- H2.
     assumption.
   rewrite <- H1.
     assumption.
   rewrite <- H1.
     rewrite <- H2.
     assumption.
   apply IHHsem2.
     assumption.
  apply Hf.
    injection H.
    intros H1 H2.
    rewrite <- H2.
    assumption.
Qed.

Theorem LogicIsSoundC:
   forall g : Env,
   forall c : Comm,
   forall P : Pred g,
   forall Q : Pred g,
   SpecC g c P Q ->
   forall s : Store g,
   forall s' : Store g,
   semC g c s s' ->
      P s -> Q s'
.
Proof.
intros g c P Q Hspec.
induction Hspec.
 intros s s' Hsem.
   inversion Hsem.
   trivial.
 intros s s' Hsem.
   inversion Hsem.
   intro Hpre.
   apply LogicIsSoundE with
       (e := e)
       (P := P)
       (F := fun (v : semT (g x)) (s : Store g) => Q (updateStore g x v s)).
  assumption.
  assumption.
  assumption.
 intros s s' Hsem.
   inversion Hsem.
   intro Hpre.
   apply IHHspec2 with (s := s1).
  assumption.
  apply IHHspec1 with (s := s).
   assumption.
   assumption.
 intros s s' Hsem.
   inversion Hsem.
  intro Hpre.
    apply IHHspec1 with (s := s).
   assumption.
   apply LogicIsSoundE with (e := e) (P := P) (F := F).
    assumption.
    assumption.
    assumption.
  intro Hpre.
    apply IHHspec2 with (s := s).
   assumption.
   apply LogicIsSoundE with (e := e) (P := P) (F := F).
    assumption.
    assumption.
    assumption.
 intros s s' Hsem.
   apply while_ind with
     (e := e)
     (c := c)
     (P := fun s s' : Store g => P s -> F false s').
  intros se Hseme Hpre.
    apply LogicIsSoundE with (e := e) (P := P) (F := F).
   assumption.
   assumption.
   assumption.
  intros se sc sf Hseme Hsemc Hsem' HI Hpre.
    apply HI.
    apply IHHspec with (s := se).
   assumption.
   apply LogicIsSoundE with (e := e) (P := P) (F := F).
    assumption.
    assumption.
    assumption.
  assumption.
 intros s s' Hsem Hpre.
   apply IHHspec with (s := s).
  assumption.
  apply p.
    assumption.
 intros s s' Hsem Hpre.
   apply p.
   apply IHHspec with (s := s).
  assumption.
  assumption.
Qed.
